'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redux = require('redux');

var _reactRedux = require('../../../../../../common/react-redux');

var _presenter = require('./presenter');

var _presenter2 = _interopRequireDefault(_presenter);

var _dragAndDropUtils = require('../../../../../../common/components/shared/drag_and_drop/dragAndDropUtils');

var _dragAndDrop = require('../../../../../../common/actions/dragAndDrop');

var _modal = require('../../../../../../common/actions/modal');

var modalActions = _interopRequireWildcard(_modal);

var _modifications = require('../../../../../../common/actions/modifications');

var _quizEntries = require('../../../../../api/quizEntries');

var _ui = require('../../../../../../common/actions/ui');

var _stateHelper = require('../../../../../../common/util/stateHelper');

var _stateHelper2 = _interopRequireDefault(_stateHelper);

var _constants = require('quiz-common/lib/constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapStateToProps(state) {
  var activeQuiz = _stateHelper2.default.activeQuiz();
  var quizId = activeQuiz.id;
  var quizEntriesIncludingTemp = activeQuiz.getWorkingQuizEntries();

  return {
    dndPositionObj: state.get('dragAndDrop'),
    quizId: quizId, // needed for DND
    quiz: activeQuiz,
    workingQuiz: activeQuiz.getWorkingInstance(),
    quizEntries: quizEntriesIncludingTemp
  };
}

function mapDispatchToProps(dispatch) {
  return {
    moveQuizEntry: (0, _redux.bindActionCreators)(_quizEntries.moveQuizEntry, dispatch), // Needed for DND
    moveTemporaryQuizEntry: (0, _redux.bindActionCreators)(_modifications.moveTemporaryQuizEntry, dispatch), // Needed for DND
    newHoverPosition: (0, _redux.bindActionCreators)(_dragAndDrop.newHoverPosition, dispatch), // Needed for DND
    openMoveImmutableModal: (0, _redux.bindActionCreators)(modalActions, dispatch).openMoveImmutableModal, // Needed for DND
    setUi: (0, _redux.bindActionCreators)(_ui.set, dispatch) // Needed for DND
  };
}

// BuildContent is a dropTarget to handle drops that occur on the page,
// but not directly on a quizEntry (such as at the top or bottom of the page).
// it also uses the isOver prop to conditionally render dropZones on Build vs Sidebar
exports.default = (0, _redux.compose)((0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps), (0, _dragAndDropUtils.DropTargetCreator)(_constants.QUIZ_ENTRY_REF))(_presenter2.default);