'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactImmutableProptypes = require('react-immutable-proptypes');

var _reactImmutableProptypes2 = _interopRequireDefault(_reactImmutableProptypes);

var _partial = require('lodash/partial');

var _partial2 = _interopRequireDefault(_partial);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _immutable = require('immutable');

var _ipaddr = require('ipaddr.js');

var _ipaddr2 = _interopRequireDefault(_ipaddr);

var _Button = require('@instructure/ui-buttons/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _IconTrashLine = require('instructure-icons/lib/Line/IconTrashLine');

var _IconTrashLine2 = _interopRequireDefault(_IconTrashLine);

var _Link = require('@instructure/ui-elements/lib/components/Link');

var _Link2 = _interopRequireDefault(_Link);

var _ScreenReaderContent = require('@instructure/ui-a11y/lib/components/ScreenReaderContent');

var _ScreenReaderContent2 = _interopRequireDefault(_ScreenReaderContent);

var _TextInput = require('@instructure/ui-forms/lib/components/TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _formatMessage = require('quiz-common/lib/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _Errors = require('../../../../../../common/components/shared/errors/Errors');

var _Errors2 = _interopRequireDefault(_Errors);

var _Setting = require('../Setting');

var _Setting2 = _interopRequireDefault(_Setting);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.IpFilter__styles__rangeSeparator {\n  margin: 0;\n  padding: 0 ' + theme.separatorPadding + ' 0 ' + theme.separatorPadding + ';\n}\n\n.IpFilter__styles__filterItem {\n  margin: 0;\n  padding-bottom: ' + theme.filterItemPadding + ';\n}\n\n.IpFilter__styles__sectionWrapper {\n  font-family: ' + theme.fontFamily + ';\n  font-size: ' + theme.fontSize + ';\n}\n';
  },
  'rangeSeparator': 'IpFilter__styles__rangeSeparator',
  'filterItem': 'IpFilter__styles__filterItem',
  'sectionWrapper': 'IpFilter__styles__sectionWrapper'
};


var START_RANGE_INPUT_INDEX = 0;
var END_RANGE_INPUT_INDEX = 1;
var DELETE_FILTER_INDEX = 2;

var IpFilter = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(IpFilter, _Component);

  function IpFilter() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, IpFilter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = IpFilter.__proto__ || Object.getPrototypeOf(IpFilter)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      errors: (0, _immutable.List)()
    }, _this.filterRefs = (0, _immutable.List)(), _this.setIpFilters = function (ips) {
      _this.props.setIpFiltersUi(_this.props.activeQuizId, ips);
      _this.updateIpFiltersApi();
    }, _this.focusOnFilter = function () {
      var setFocusOnColumnIndex = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var setFocusOnRowIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      setTimeout(function () {
        var rowFocusIndex = setFocusOnRowIndex;
        if (rowFocusIndex === null) {
          rowFocusIndex = _this.ipFilters.size - 1;
        }
        var filter = _this.filterRefs.getIn([rowFocusIndex, setFocusOnColumnIndex]);
        filter && filter.focus();
      });
    }, _this.updateIpFiltersApi = (0, _debounce2.default)(function () {
      // The store will always have a valid input
      _this.props.setIpFiltersApi(_this.props.activeQuizId, _this.ipFilters);
    }), _this.setFilterRef = function (index, rangePart, ref) {
      if (!_this.filterRefs.has(index)) {
        _this.filterRefs = _this.filterRefs.set(index, (0, _immutable.List)());
      }
      _this.filterRefs = _this.filterRefs.setIn([index, rangePart], ref);
    }, _this.setAddFilterRef = function (node) {
      _this.addFilterRef = node;
    }, _this.getFilterValues = function (filters, index) {
      if (_this.state.errors.get(index) && _this.filterRefs.get(index)) {
        return _this.filterRefs.get(index).map(function (ref) {
          return ref ? ref.value : '';
        });
      }
      return filters;
    }, _this.toggleFilterIpAddress = function (event) {
      var value = event.target.checked;
      _this.props.setFilterIpAddress(_this.props.activeQuizId, value);
    }, _this.handleFilterAdd = function (event) {
      _this.setIpFilters(_this.ipFilters.push((0, _immutable.List)(['', ''])));
      _this.focusOnFilter();
      _this.props.screenreaderNotification('Ip Filter Range Input Fields tilf\xF8jet.');
    }, _this.handleFilterRemove = function (index) {
      // Remove saved node refs and errors too
      _this.filterRefs = _this.filterRefs.remove(index);
      _this.setState({ errors: _this.state.errors.remove(index) });

      var columnFocusIndex = _this.ipFilters.size > 2 ? DELETE_FILTER_INDEX : START_RANGE_INPUT_INDEX;
      var rowFocusIndex = _this.ipFilters.size - 1 === index ? index - 1 : index;

      _this.setIpFilters(_this.ipFilters.remove(index));
      _this.focusOnFilter(columnFocusIndex, rowFocusIndex);
      _this.props.screenreaderNotification('IP-flter omr\xE5deinput-felter fjernet.');
    }, _this.handleFilterChange = function (index, rangePart, event) {
      var ipval = event.target.value.trim();

      var filterErrs = _this.state.errors.get(index) || (0, _immutable.List)();
      if (ipval === '' || _ipaddr2.default.IPv4.isValid(ipval) && /\./.test(ipval)) {
        filterErrs = filterErrs.set(rangePart, null);
        _this.setIpFilters(_this.ipFilters.setIn([index, rangePart], ipval));
      } else {
        filterErrs = filterErrs.set(rangePart, 'IP-adressen ' + ipval + ' er ugyldig.');
      }

      // See if we can clear out the errors for this while thing
      if (filterErrs.filter(function (x) {
        return !!x;
      }).size === 0) {
        _this.setState({ errors: _this.state.errors.remove(index) });
      } else {
        _this.setState({ errors: _this.state.errors.set(index, filterErrs) });
      }
    }, _this.rangeIsValid = function (lhs, rhs) {
      for (var i = 0; i < 4; i++) {
        if (lhs[i] > rhs[i]) {
          return false;
        } else if (lhs[i] < rhs[i]) {
          return true;
        }
      }
      return true;
    }, _this.getRangeErrors = function (values) {
      var startval = values.get(START_RANGE_INPUT_INDEX);
      var endval = values.get(END_RANGE_INPUT_INDEX);

      if (!startval && !endval) {
        return null; // ignore fully empty ranges
      } else if (!startval || !endval) {
        return (0, _immutable.List)(['Ufuldst\xE6ndigt IP-omr\xE5de']);
      } else if (_ipaddr2.default.IPv4.isValid(startval) && _ipaddr2.default.IPv4.isValid(endval)) {
        try {
          var rangeStart = _ipaddr2.default.parse(startval);
          var rangeEnd = _ipaddr2.default.parse(endval);
          if (!_this.rangeIsValid(rangeStart.octets, rangeEnd.octets)) {
            // compare  IPs in the same family using the first > or < byte
            return (0, _immutable.List)(['Ugyldigt IP-omr\xE5de: ' + startval + ' er st\xF8rre end ' + endval]);
          }
        } catch (ex) {
          // This is already taken care of by the first portion of the validation
        }
      }
    }, _this.renderIpFilter = function (filter, index) {
      var values = _this.getFilterValues(filter, index);

      return _react2.default.createElement(
        'div',
        { key: index, className: styles.filterItem },
        _react2.default.createElement(_TextInput2.default, {
          label: _react2.default.createElement(
            _ScreenReaderContent2.default,
            null,
            'Interval start'
          ),
          inline: true,
          type: 'text',
          value: values.get(START_RANGE_INPUT_INDEX),
          placeholder: 'fx 0.0.0.0',
          ref: (0, _partial2.default)(_this.setFilterRef, index, START_RANGE_INPUT_INDEX),
          onChange: (0, _partial2.default)(_this.handleFilterChange, index, START_RANGE_INPUT_INDEX),
          'data-automation': 'sdk-ipFiltering-start'
        }),
        _react2.default.createElement(
          'span',
          { className: styles.rangeSeparator },
          'til'
        ),
        _react2.default.createElement(_TextInput2.default, {
          label: _react2.default.createElement(
            _ScreenReaderContent2.default,
            null,
            'Interval slut'
          ),
          inline: true,
          type: 'text',
          value: values.get(END_RANGE_INPUT_INDEX),
          placeholder: 'fx 255.255.255.255',
          ref: (0, _partial2.default)(_this.setFilterRef, index, END_RANGE_INPUT_INDEX),
          onChange: (0, _partial2.default)(_this.handleFilterChange, index, END_RANGE_INPUT_INDEX),
          'data-automation': 'sdk-ipFiltering-end'
        }),
        _this.renderTrashButton(index),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_Errors2.default, { errorList: _this.state.errors.get(index) || (0, _immutable.List)() }),
          _react2.default.createElement(_Errors2.default, { errorList: _this.getRangeErrors(values) || (0, _immutable.List)() })
        )
      );
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(IpFilter, [{
    key: 'renderTrashButton',


    // =============
    //   RENDERING
    // =============

    value: function renderTrashButton(index) {
      // Cannot delete the final item
      if (index === 0 && this.ipFilters.size === 1) {
        return null;
      }

      var iconText = 'Slet tomt IP-filter';

      var _getFilterValues = this.getFilterValues(this.ipFilters.get(index), index),
          _getFilterValues2 = (0, _slicedToArray3.default)(_getFilterValues, 2),
          rangeStart = _getFilterValues2[0],
          rangeEnd = _getFilterValues2[1];

      if (rangeStart && rangeEnd) {
        iconText = 'Slet IP-filter fra ' + rangeStart + ' til ' + rangeEnd;
      } else if (rangeStart) {
        iconText = 'Slet ufuldst\xE6ndigt IP-filter, der starter med ' + rangeStart;
      } else if (rangeEnd) {
        iconText = 'Slet ufuldst\xE6ndigt IP-filter, der slutter p\xE5 ' + rangeEnd;
      }

      return _react2.default.createElement(
        _Button2.default,
        {
          variant: 'icon',
          size: 'medium',
          onClick: (0, _partial2.default)(this.handleFilterRemove, index),
          ref: (0, _partial2.default)(this.setFilterRef, index, DELETE_FILTER_INDEX),
          icon: _IconTrashLine2.default
        },
        _react2.default.createElement(
          _ScreenReaderContent2.default,
          null,
          iconText
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _Setting2.default,
        {
          automationData: 'sdk-ipFiltering-toggle',
          label: 'Filtrer IP-adresser',
          isChecked: this.props.filterIpAddress,
          showMore: this.props.filterIpAddress,
          onChange: this.toggleFilterIpAddress
        },
        _react2.default.createElement(
          'div',
          { className: styles.sectionWrapper },
          'Tilladt IP-omr\xE5de',
          this.ipFilters.toArray().map(this.renderIpFilter),
          _react2.default.createElement(
            _Link2.default,
            { linkRef: this.setAddFilterRef, onClick: this.handleFilterAdd },
            '+ Tilladt omr\xE5de'
          )
        )
      );
    }
  }, {
    key: 'ipFilters',
    get: function get() {
      return this.props.filters.get('ips', (0, _immutable.List)([(0, _immutable.List)(['', ''])]));
    }

    // =================
    //   ERROR HELPERS
    // =================

  }]);
  IpFilter.displayName = 'IpFilter'
  ;
  return IpFilter;
}(_react.Component), _class2.propTypes = {
  activeQuizId: _propTypes2.default.string.isRequired,
  filterIpAddress: _propTypes2.default.bool.isRequired,
  filters: _reactImmutableProptypes2.default.map.isRequired,
  screenreaderNotification: _propTypes2.default.func.isRequired,
  setFilterIpAddress: _propTypes2.default.func.isRequired,
  setIpFiltersApi: _propTypes2.default.func.isRequired,
  setIpFiltersUi: _propTypes2.default.func.isRequired
}, _temp2)) || _class);
exports.default = IpFilter;