'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setTagSuggestions = exports.setTagInput = exports.setTagAssociations = exports.setPendingDeletionTagAssociations = exports.setPendingAdditionTagAssociations = exports.removeTagAssociation = exports.removePendingDeletionTagAssociation = exports.removePendingAdditionTagAssociation = exports.addTagAssociation = undefined;

var _constants = require('quiz-common/lib/constants');

var addTagAssociation = exports.addTagAssociation = function addTagAssociation(entityType, entityId, tagAssociation) {
  return {
    type: _constants.ADD_TAG_ASSOCIATION,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tagAssociation: tagAssociation
    }
  };
};

var removePendingAdditionTagAssociation = exports.removePendingAdditionTagAssociation = function removePendingAdditionTagAssociation(entityType, entityId, tagValue) {
  return {
    type: _constants.REMOVE_PENDING_ADDITION_TAG_ASSOCIATION,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tagValue: tagValue
    }
  };
};

var removePendingDeletionTagAssociation = exports.removePendingDeletionTagAssociation = function removePendingDeletionTagAssociation(entityType, entityId, tagAssociationId) {
  return {
    type: _constants.REMOVE_PENDING_DELETION_TAG_ASSOCIATION,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tagAssociationId: tagAssociationId
    }
  };
};

var removeTagAssociation = exports.removeTagAssociation = function removeTagAssociation(entityType, entityId, tagAssociationId) {
  return {
    type: _constants.REMOVE_TAG_ASSOCIATION,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tagAssociationId: tagAssociationId
    }
  };
};

var setPendingAdditionTagAssociations = exports.setPendingAdditionTagAssociations = function setPendingAdditionTagAssociations(entityType, entityId, tags) {
  return {
    type: _constants.SET_PENDING_ADDITION_TAG_ASSOCIATIONS,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tags: tags
    }
  };
};

var setPendingDeletionTagAssociations = exports.setPendingDeletionTagAssociations = function setPendingDeletionTagAssociations(entityType, entityId, tags) {
  return {
    type: _constants.SET_PENDING_DELETION_TAG_ASSOCIATIONS,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tags: tags
    }
  };
};

var setTagAssociations = exports.setTagAssociations = function setTagAssociations(entityType, entityId, tagAssociations) {
  return {
    type: _constants.SET_TAG_ASSOCIATIONS,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tagAssociations: tagAssociations
    }
  };
};

var setTagInput = exports.setTagInput = function setTagInput(entityType, entityId, tagInput) {
  return {
    type: _constants.SET_TAG_INPUT,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tagInput: tagInput
    }
  };
};

var setTagSuggestions = exports.setTagSuggestions = function setTagSuggestions(entityType, entityId, tags, text) {
  return {
    type: _constants.SET_TAG_SUGGESTIONS,
    payload: {
      entityType: entityType,
      entityId: entityId,
      tags: tags,
      text: text
    }
  };
};