'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var media = exports.media = {
  'phone-break-point': 'only screen and (max-width: 48rem)',
  'tablet-break-point': 'only screen and (max-width: 64rem)'
};

var onPhone = exports.onPhone = function onPhone() {
  var windowObj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window;

  var mediaQueryString = media['phone-break-point'];
  return windowObj.matchMedia(mediaQueryString).matches;
};

var onTablet = exports.onTablet = function onTablet() {
  var windowObj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window;

  var mediaQueryString = media['tablet-break-point'];
  return !onPhone(windowObj) && windowObj.matchMedia(mediaQueryString).matches;
};