'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.archiveBank = exports.removeBank = exports.disassociateEntry = exports.associateEntries = exports.setBankFilters = exports.addBanks = undefined;

var _constants = require('quiz-common/lib/constants');

var addBanks = exports.addBanks = function addBanks(banks) {
  return {
    type: _constants.ADD_BANKS,
    payload: banks
  };
};

var setBankFilters = exports.setBankFilters = function setBankFilters(bankId, filters) {
  return {
    type: _constants.SET_BANK_FILTERS, payload: { bankId: bankId, filters: filters }
  };
};

var associateEntries = exports.associateEntries = function associateEntries(bankId, bankEntryIds) {
  return {
    type: _constants.ASSOCIATE_ENTRIES,
    payload: { bankId: bankId, bankEntryIds: bankEntryIds }
  };
};

var disassociateEntry = exports.disassociateEntry = function disassociateEntry(bankId, bankEntryId) {
  return {
    type: _constants.DISASSOCIATE_ENTRY,
    payload: { bankId: bankId, bankEntryId: bankEntryId }
  };
};

var removeBank = exports.removeBank = function removeBank(bankId) {
  return {
    type: _constants.REMOVE_BANK,
    payload: bankId
  };
};

var archiveBank = exports.archiveBank = function archiveBank(bankId) {
  return {
    type: _constants.ARCHIVE_BANK,
    payload: bankId
  };
};