'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = undefined;

var _IconPlusLine = require('instructure-icons/lib/Line/IconPlusLine');

var _IconPlusLine2 = _interopRequireDefault(_IconPlusLine);

var _formatMessage = require('quiz-common/lib/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from 'instructure-icons/lib/Line/<insert icon name here>'
// import EssayIcon from 'instructure-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {
    // TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlusLine2.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: 'Categorizaci\xF3n',
    choice: 'Selecci\xF3n m\xFAltiple',
    essay: 'Ensayo',
    'file-upload': 'Carga del archivo',
    'fill-blank': 'Rellenar el espacio en blanco',
    formula: 'F\xF3rmula',
    'hot-spot': 'Zona activa',
    matching: 'Combinaciones',
    'multi-answer': 'Respuestas m\xFAltiples',
    numeric: 'Num\xE9rico',
    ordering: 'Ordenar',
    'true-false': 'Verdadero o falso'
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = exports.interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};