'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapStateToProps = mapStateToProps;

var _reactRedux = require('../../../../../common/react-redux');

var _QuizSession = require('../../../../../common/records/QuizSession');

var _QuizSession2 = _interopRequireDefault(_QuizSession);

var _presenter = require('./presenter');

var _presenter2 = _interopRequireDefault(_presenter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapStateToProps(state, ownProps) {
  var quizSessionId = ownProps.quizSessionId;
  var quizSession = _QuizSession2.default.create(state.getIn(['quizSessions', quizSessionId]));
  var sessionItems = quizSession.getSessionItems();
  var isOneQuestionAtATime = quizSession.isOneQuestionAtATime();
  var sessionItemsCount = quizSession.get('sessionItemsCount') || 0;
  var allowBacktracking = quizSession.allowBacktracking;
  var showProgress = !allowBacktracking;

  return {
    isOneQuestionAtATime: isOneQuestionAtATime,
    sessionItems: sessionItems,
    sessionItemsCount: sessionItemsCount,
    showProgress: showProgress
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, null)(_presenter2.default);