---
category: components
name: GradingHeader
---
```jsx_example
function Example () {
  const quizSession = new records.QuizSession({
    elapsedTime: 314
  })

  const quizSessionResult = new records.QuizSessionResult({
    percentage: 0.725,
    pointsPossible: 20,
    score: 14.5
  })

  const sessionItemResults = new immutable.List([
    new records.SessionItemResult({
      position: '1',
      score: null
    })
  ])

  return (
    <SDKApp
      apiEndpoint={`http://${config.API_HOST}`}
      appContainer="#app"
      userToken={config.TOKEN_QUIZ_BUILD_ANY}
    >
      <GradingHeader
        quizSession={quizSession}
        quizSessionResult={quizSessionResult}
        sessionItemResults={sessionItemResults}
      />
    </SDKApp>
  )
}

<LocaleSwitcher>
  <Example />
</LocaleSwitcher>
```
