'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react3 = require('format-message/react');

var _Alert = require('@instructure/ui-alerts/lib/components/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _Button = require('@instructure/ui-buttons/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _CloseButton = require('@instructure/ui-buttons/lib/components/CloseButton');

var _CloseButton2 = _interopRequireDefault(_CloseButton);

var _Heading = require('@instructure/ui-elements/lib/components/Heading');

var _Heading2 = _interopRequireDefault(_Heading);

var _RadioInput = require('@instructure/ui-forms/lib/components/RadioInput');

var _RadioInput2 = _interopRequireDefault(_RadioInput);

var _RadioInputGroup = require('@instructure/ui-forms/lib/components/RadioInputGroup');

var _RadioInputGroup2 = _interopRequireDefault(_RadioInputGroup);

var _Text = require('@instructure/ui-elements/lib/components/Text');

var _Text2 = _interopRequireDefault(_Text);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _Modal = require('../../../common/components/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _constants = require('quiz-common/lib/constants');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

var _formatMessage = require('quiz-common/lib/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.RegradingModal__styles__alert {\n  padding-bottom: ' + theme.alertBottomPadding + ';\n}\n\n.RegradingModal__styles__radioInputGroup {\n  padding-bottom: ' + theme.radioInputGroupBottomPadding + ';\n}\n\n.RegradingModal__styles__select {\n  padding: 0 1.6rem ' + theme.selectPadding + ';\n}\n';
  },
  'alert': 'RegradingModal__styles__alert',
  'radioInputGroup': 'RegradingModal__styles__radioInputGroup',
  'select': 'RegradingModal__styles__select'
};
var RegradingModal = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(RegradingModal, _Component);

  function RegradingModal() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, RegradingModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = RegradingModal.__proto__ || Object.getPrototypeOf(RegradingModal)).call.apply(_ref, [this].concat(args))), _this), _this.cancelAction = function () {
      _this.props.closeModal();
    }, _this.onSpeedgraderOptionChange = function (event, newValue) {
      _this.props.setScoreReconciliation(newValue);
    }, _this.onSubmit = function () {
      var _this$props = _this.props,
          createQuizEntryRegrade = _this$props.createQuizEntryRegrade,
          quizId = _this$props.quizId,
          regradingPayload = _this$props.regradingPayload,
          scoreReconciliation = _this$props.scoreReconciliation;


      createQuizEntryRegrade(quizId, Object.assign({}, regradingPayload, { scoreReconciliation: scoreReconciliation })).then(function () {
        _this.props.toggleRegradingEditMode('');
        _this.props.addSuccess('\u518D\u8A55\u4FA1\u306F\u6B63\u5E38\u306B\u30B9\u30B1\u30B8\u30E5\u30FC\u30EB\u3055\u308C\u307E\u3057\u305F\u3002\u9069\u7528\u3055\u308C\u3066\u3044\u308B\u3053\u3068\u3092\u5F8C\u3067\u78BA\u8A8D\u3057\u3066\u304F\u3060\u3055\u3044\u3002');
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(RegradingModal, [{
    key: 'cancelButton',


    // Rendering

    value: function cancelButton() {
      return _react2.default.createElement(
        _Button2.default,
        {
          margin: _constants.XSMALL_SIDE_MARGIN,
          onClick: this.cancelAction,
          ref: this.setRef('cancelImportButton')
        },
        '\u30AD\u30E3\u30F3\u30BB\u30EB'
      );
    }
  }, {
    key: 'regradeButton',
    value: function regradeButton() {
      return _react2.default.createElement(
        _Button2.default,
        {
          margin: _constants.XSMALL_SIDE_MARGIN,
          onClick: this.onSubmit,
          ref: this.setRef('confirmButton'),
          variant: 'primary',
          'data-automation': 'sdk-regrade-button'
        },
        '\u518D\u5EA6\u63A1\u70B9'
      );
    }
  }, {
    key: 'setRef',
    value: function setRef(refName) {
      var _this2 = this;

      return function (node) {
        _this2[refName] = node;
      };
    }
  }, {
    key: 'renderOptionInputs',
    value: function renderOptionInputs() {
      return Object.entries(this.optionInputs).map(function (optionInput) {
        return _react2.default.createElement(
          'option',
          { key: optionInput[0], value: optionInput[0] },
          optionInput[1].text
        );
      });
    }
  }, {
    key: 'renderRadioInputs',
    value: function renderRadioInputs() {
      return Object.entries(this.optionInputs).map(function (optionInput) {
        return _react2.default.createElement(_RadioInput2.default, {
          label: optionInput[1].text,
          value: optionInput[0],
          key: optionInput[0]
        });
      });
    }
  }, {
    key: 'renderModalBody',
    value: function renderModalBody() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _Alert2.default,
          {
            margin: 'small 0',
            transition: 'none',
            variant: 'info'
          },
          _react2.default.createElement(
            'div',
            { className: styles.alert },
            _react2.default.createElement(
              'p',
              null,
              (0, _react3.formatChildren)('\n                  <0>\u518D\u8A55\u4FA1\u306F\u7D42\u4E86\u3057\u305F\u63D0\u51FA\u7269\u306B\u306E\u307F\u9069\u7528\u3055\u308C\u307E\u3059\u3002</0>\n                  <1>\u3059\u3079\u3066\u306E\u5B66\u751F\u304C\u5F71\u97FF\u3092\u53D7\u3051\u3066\u3044\u308B\u5834\u5408\u306F\u3001\u3059\u3079\u3066\u306E\u63D0\u51FA\u304C\u7D42\u308F\u308B\u307E\u3067\u518D\u8A55\u4FA1\u3092\u5F85\u3061\u307E\u3059\u3002</1>\n                ', [_react2.default.createElement(_Text2.default, { as: 'div', weight: 'bold', key: '0' }), _react2.default.createElement(_Text2.default, { as: 'span', key: '1' })])
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: styles.radioInputGroup, role: 'form' },
          _react2.default.createElement(
            _RadioInputGroup2.default,
            {
              description: '\u3053\u306E\u518D\u5EA6\u63A1\u70B9\u306E\u9069\u7528\u65B9\u6CD5\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044\u3002',
              name: 'scoring_reconciliation',
              onChange: this.onSpeedgraderOptionChange,
              messages: this.selectHint,
              value: this.scoreReconciliation
            },
            this.renderRadioInputs()
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _Modal2.default,
        {
          open: this.props.modalOpen,
          size: 'medium',
          onDismiss: this.cancelAction,
          label: '\u30A2\u30A4\u30C6\u30E0\u306E\u518D\u5EA6\u63A1\u70B9\u30AA\u30D7\u30B7\u30E7\u30F3',
          ref: this.setRef('modal'),
          'data-automation': 'sdk-regrade-modal',
          shouldCloseOnDocumentClick: false
        },
        _react2.default.createElement(
          _Modal.ModalHeader,
          null,
          _react2.default.createElement(
            _Heading2.default,
            { level: 'reset', as: 'h2' },
            '\u30A2\u30A4\u30C6\u30E0\u306E\u518D\u5EA6\u63A1\u70B9\u30AA\u30D7\u30B7\u30E7\u30F3'
          ),
          _react2.default.createElement(_CloseButton2.default, {
            onClick: this.cancelAction,
            placement: 'end',
            offset: 'medium',
            variant: 'icon'
          })
        ),
        _react2.default.createElement(
          _Modal.ModalBody,
          null,
          this.renderModalBody()
        ),
        _react2.default.createElement(
          _Modal.ModalFooter,
          null,
          this.cancelButton(),
          this.regradeButton()
        )
      );
    }
  }, {
    key: 'optionInputs',


    // Getters
    get: function get() {
      return {
        new_score: {
          hint: '\u5F97\u70B9\u304C\u5F15\u304D\u4E0B\u3052\u3089\u308C\u308B\u3082\u306E\u3082\u3042\u308C\u3070\u3001\u5F15\u304D\u4E0A\u3052\u3089\u308C\u3082\u306E\u3082\u3042\u308B\u3067\u3057\u3087\u3046',
          text: '\u6B63\u89E3\u306E\u307F\u306E\u30DD\u30A4\u30F3\u30C8\u5F97\u70B9'
        },
        old_score: {
          hint: '\u30B9\u30B3\u30A2\u306F\u6E1B\u5C11\u3057\u307E\u305B\u3093',
          text: '\u73FE\u5728\u306E\u56DE\u7B54\u3068\u4EE5\u524D\u306E\u56DE\u7B54\u306E\u4E21\u65B9\u306B\u30DD\u30A4\u30F3\u30C8\u3092\u4E0E\u3048\u308B'
        },
        any_response: {
          hint: '\u7B54\u3048\u305F\u4EBA\u306F\u5168\u54E1\u5168\u5358\u4F4D\u3092\u5F97\u308B',
          text: '\u63D0\u51FA\u3055\u308C\u305F\u56DE\u7B54\u3059\u3079\u3066\u306B\u30DD\u30A4\u30F3\u30C8\u3092\u4E0E\u3048\u308B'
        },
        thrown_out: {
          hint: '\u6295\u3052\u51FA\u3055\u308C\u305F\u8CEA\u554F',
          text: '\u5168\u54E1\u306B\u5168\u5358\u4F4D\u3092\u4E0E\u3048\u308B'
        }
      };
    }
  }, {
    key: 'scoreReconciliation',
    get: function get() {
      return this.props.scoreReconciliation;
    }
  }, {
    key: 'selectHint',
    get: function get() {
      var hint = this.optionInputs[this.scoreReconciliation].hint;
      return [{
        text: '\u7D50\u679C\uFF1A' + hint,
        type: 'hint'
      }];
    }

    // Handlers

  }]);
  RegradingModal.displayName = 'RegradingModal'
  ;
  return RegradingModal;
}(_react.Component), _class2.propTypes = {
  addSuccess: _propTypes2.default.func.isRequired,
  closeModal: _propTypes2.default.func.isRequired,
  createQuizEntryRegrade: _propTypes2.default.func.isRequired,
  modalOpen: _propTypes2.default.bool.isRequired,
  quizId: _propTypes2.default.string.isRequired,
  regradingPayload: _propTypes2.default.shape({
    quizEntryId: _propTypes2.default.string.isRequired,
    scoringAlgorithm: _propTypes2.default.string,
    scoringData: _propTypes2.default.object
  }).isRequired,
  scoreReconciliation: _propTypes2.default.string.isRequired,
  setScoreReconciliation: _propTypes2.default.func.isRequired,
  toggleRegradingEditMode: _propTypes2.default.func.isRequired }, _temp2)) || _class);
exports.default = RegradingModal;