'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactImmutableProptypes = require('react-immutable-proptypes');

var _reactImmutableProptypes2 = _interopRequireDefault(_reactImmutableProptypes);

var _Heading = require('@instructure/ui-elements/lib/components/Heading');

var _Heading2 = _interopRequireDefault(_Heading);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _formatMessage = require('quiz-common/lib/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _ItemBanksButton = require('../ItemBanksButton');

var _ItemBanksButton2 = _interopRequireDefault(_ItemBanksButton);

var _OutcomesEditButton = require('../OutcomesEditButton');

var _OutcomesEditButton2 = _interopRequireDefault(_OutcomesEditButton);

var _OutcomesEditPanel = require('../OutcomesEditPanel');

var _OutcomesEditPanel2 = _interopRequireDefault(_OutcomesEditPanel);

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.Header__styles__headerRows {\n  display: flex;\n  flex-direction: column;\n  justify-content: space-between;\n  max-width: calc(' + theme.maxContentWidth + ' + ' + theme.headerPadding + ' * 2);\n  margin: 0 auto;\n}\n\n.Header__styles__headerRow {\n  display: flex;\n  align-items: center;\n  justify-content: space-between;\n  padding-left: ' + theme.headerPadding + ';\n  padding-right: ' + theme.headerPadding + ';\n}\n\n.Header__styles__buttons {\n  display: flex;\n}\n\n.Header__styles__button {\n  padding: 0.5rem;\n}\n\n.Header__styles__button:last-of-type {\n  padding-right: 0;\n}\n';
  },
  'headerRows': 'Header__styles__headerRows',
  'headerRow': 'Header__styles__headerRow',
  'buttons': 'Header__styles__buttons',
  'button': 'Header__styles__button'
};
var BaseHeader = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(BaseHeader, _Component);

  function BaseHeader() {
    (0, _classCallCheck3.default)(this, BaseHeader);
    return (0, _possibleConstructorReturn3.default)(this, (BaseHeader.__proto__ || Object.getPrototypeOf(BaseHeader)).apply(this, arguments));
  }

  (0, _createClass3.default)(BaseHeader, [{
    key: 'renderButtons',
    value: function renderButtons() {
      var buttons = [];
      var _props = this.props,
          itemBanksButtonRef = _props.itemBanksButtonRef,
          onItemBanksClick = _props.onItemBanksClick,
          outcomesEndpoint = _props.outcomesEndpoint,
          outcomesToken = _props.outcomesToken,
          quiz = _props.quiz;


      if (onItemBanksClick && itemBanksButtonRef) {
        buttons.push({
          key: 'item_banks',
          component: _react2.default.createElement(_ItemBanksButton2.default, {
            instUiButtonRef: itemBanksButtonRef,
            onClick: onItemBanksClick
          })
        });
      }

      if (outcomesEndpoint) {
        buttons.push({
          key: 'outcome_alignments',
          component: _react2.default.createElement(_OutcomesEditButton2.default, {
            quiz: quiz,
            contextUuid: this.props.contextUuid,
            outcomesEndpoint: outcomesEndpoint,
            outcomesToken: outcomesToken,
            guid: 'outcomes-edit',
            'data-automation': 'sdk-header-outcomes-edit-button'
          })
        });
      }
      if (buttons.length > 0) {
        return _react2.default.createElement(
          'div',
          { className: styles.buttons },
          buttons.map(function (_ref) {
            var key = _ref.key,
                component = _ref.component;

            return _react2.default.createElement(
              'div',
              { key: key, className: styles.button },
              component
            );
          })
        );
      } else {
        return null;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: styles.headerRows },
        _react2.default.createElement(
          'div',
          { className: styles.headerRow },
          _react2.default.createElement(
            _Heading2.default,
            { level: 'h1' },
            'Samenstellen'
          ),
          this.renderButtons()
        ),
        this.props.outcomesEndpoint ? _react2.default.createElement(_OutcomesEditPanel2.default, {
          quiz: this.props.quiz,
          contextUuid: this.props.contextUuid,
          outcomesEndpoint: this.props.outcomesEndpoint,
          outcomesToken: this.props.outcomesToken,
          guid: 'outcomes-edit'
        }) : null
      );
    }
  }]);
  BaseHeader.displayName = 'BaseHeader'
  ;
  return BaseHeader;
}(_react.Component), _class2.propTypes = {
  quiz: _reactImmutableProptypes2.default.record.isRequired,
  contextUuid: _propTypes2.default.string.isRequired,
  outcomesEndpoint: _propTypes2.default.string,
  outcomesToken: _propTypes2.default.string,
  onItemBanksClick: _propTypes2.default.func,
  itemBanksButtonRef: _propTypes2.default.func
}, _class2.defaultProps = {
  outcomesEndpoint: null,
  outcomesToken: null,
  onItemBanksClick: null,
  itemBanksButtonRef: null
}, _temp)) || _class);
exports.default = BaseHeader;