'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _TextInput = require('@instructure/ui-forms/lib/components/TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

var _Text = require('@instructure/ui-elements/lib/components/Text');

var _Text2 = _interopRequireDefault(_Text);

var _ScreenReaderContent = require('@instructure/ui-a11y/lib/components/ScreenReaderContent');

var _ScreenReaderContent2 = _interopRequireDefault(_ScreenReaderContent);

var _formatMessage = require('quiz-common/lib/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _Setting = require('../Setting');

var _Setting2 = _interopRequireDefault(_Setting);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StudentAccessCode = (_temp2 = _class = function (_Component) {
  (0, _inherits3.default)(StudentAccessCode, _Component);

  function StudentAccessCode() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, StudentAccessCode);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = StudentAccessCode.__proto__ || Object.getPrototypeOf(StudentAccessCode)).call.apply(_ref, [this].concat(args))), _this), _this.toggleStudentAccessCode = function (event) {
      var _this$props = _this.props,
          setRequireStudentAccessCode = _this$props.setRequireStudentAccessCode,
          activeQuizId = _this$props.activeQuizId;

      setRequireStudentAccessCode(activeQuizId, event.target.checked);
    }, _this.updateAccessCodeApi = (0, _debounce2.default)(function () {
      var _this$props2 = _this.props,
          setStudentAccessCodeApi = _this$props2.setStudentAccessCodeApi,
          activeQuizId = _this$props2.activeQuizId;

      setStudentAccessCodeApi(activeQuizId, _this.accessCodeInput.value);
    }, 300), _this.setNewAccessCode = function (event) {
      var _this$props3 = _this.props,
          setStudentAccessCodeUi = _this$props3.setStudentAccessCodeUi,
          activeQuizId = _this$props3.activeQuizId;

      setStudentAccessCodeUi(activeQuizId, _this.accessCodeInput.value);
      _this.updateAccessCodeApi();
    }, _this.setTextInputRef = function (ti) {
      _this.accessCodeInput = ti;
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(StudentAccessCode, [{
    key: 'studentAccessCode',
    value: function studentAccessCode() {
      return this.props.studentAccessCode || '';
    }

    // =============
    //    ACTIONS
    // =============

  }, {
    key: 'render',


    // =============
    //   RENDERING
    // =============

    value: function render() {
      return _react2.default.createElement(
        _Setting2.default,
        {
          automationData: 'sdk-accessCode-toggle',
          isChecked: this.props.requireStudentAccessCode,
          showMore: this.props.requireStudentAccessCode,
          label: 'Exige um c\xF3digo de acesso do aluno',
          onChange: this.toggleStudentAccessCode
        },
        _react2.default.createElement(_TextInput2.default, {
          inputRef: this.setTextInputRef,
          label: _react2.default.createElement(
            _ScreenReaderContent2.default,
            null,
            'C\xF3digo de acesso'
          ),
          inline: true,
          value: this.studentAccessCode(),
          type: 'text',
          placeholder: 'Senha',
          onChange: this.setNewAccessCode,
          'data-automation': 'sdk-accessCode-textBox'
        }),
        _react2.default.createElement('br', null),
        _react2.default.createElement(
          _Text2.default,
          { weight: 'light', color: 'secondary', size: 'small' },
          'Deixar em branco para sem c\xF3digo de acesso'
        )
      );
    }
  }]);
  StudentAccessCode.displayName = 'StudentAccessCode'
  ;
  return StudentAccessCode;
}(_react.Component), _class.propTypes = {
  activeQuizId: _propTypes2.default.string.isRequired,
  requireStudentAccessCode: _propTypes2.default.bool.isRequired,
  setStudentAccessCodeApi: _propTypes2.default.func.isRequired,
  setStudentAccessCodeUi: _propTypes2.default.func.isRequired,
  setRequireStudentAccessCode: _propTypes2.default.func.isRequired,
  studentAccessCode: _propTypes2.default.string
}, _class.defaultProps = {
  studentAccessCode: ''
}, _temp2);
exports.default = StudentAccessCode;