'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.disassociateQuizEntry = exports.associateQuizEntries = exports.associateQuizAnalysis = exports.associateItemAnalyses = exports.newActiveQuiz = exports.addQuizzes = undefined;

var _constants = require('quiz-common/lib/constants');

var addQuizzes = exports.addQuizzes = function addQuizzes(quizzes) {
  return {
    type: _constants.ADD_QUIZZES,
    payload: quizzes
  };
};

var newActiveQuiz = exports.newActiveQuiz = function newActiveQuiz(activeQuizId) {
  return {
    type: _constants.ACTIVE_QUIZ_CHANGE,
    payload: activeQuizId
  };
};

var associateItemAnalyses = exports.associateItemAnalyses = function associateItemAnalyses(quizId, itemAnalyses) {
  return {
    type: _constants.ASSOCIATE_ITEM_ANALYSES,
    payload: { quizId: quizId, itemAnalyses: itemAnalyses }
  };
};

var associateQuizAnalysis = exports.associateQuizAnalysis = function associateQuizAnalysis(quizId, quizAnalysis) {
  return {
    type: _constants.ASSOCIATE_QUIZ_ANALYSIS,
    payload: { quizId: quizId, quizAnalysis: quizAnalysis }
  };
};

var associateQuizEntries = exports.associateQuizEntries = function associateQuizEntries(quizId, quizEntries) {
  return {
    type: _constants.ASSOCIATE_QUIZ_ENTRIES,
    payload: { quizId: quizId, quizEntries: quizEntries }
  };
};

var disassociateQuizEntry = exports.disassociateQuizEntry = function disassociateQuizEntry(quizId, quizEntryId) {
  return {
    type: _constants.DISASSOCIATE_QUIZ_ENTRY,
    payload: { quizId: quizId, quizEntryId: quizEntryId }
  };
};