'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec,
    _class,
    _class2,
    _temp,
    _initialiseProps,
    _default_zhHans_number = Intl.NumberFormat('zh-Hans', { style: 'decimal' }).format;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutable = require('immutable');

var _quizNumberInput = require('@instructure/quiz-number-input');

var _quizNumberInput2 = _interopRequireDefault(_quizNumberInput);

var _Text = require('@instructure/ui-elements/lib/components/Text');

var _Text2 = _interopRequireDefault(_Text);

var _lib = require('@instructure/ui-themeable/lib');

var _lib2 = _interopRequireDefault(_lib);

var _formatMessage = require('quiz-common/lib/format-message');

var _formatMessage2 = _interopRequireDefault(_formatMessage);

var _Setting = require('../Setting');

var _Setting2 = _interopRequireDefault(_Setting);

var _Errors = require('../../../../../../common/components/shared/errors/Errors');

var _Errors2 = _interopRequireDefault(_Errors);

var _FormattedDuration = require('../../../../../../common/components/shared/FormattedDuration');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  template: function template(theme) {
    return '/*  imported from styles.css  */\n\n.Timer__styles__wrapper {\n  display: flex;\n  flex-direction: column;\n}\n\n.Timer__styles__inputsWrapper {\n  display: flex;\n}\n\n.Timer__styles__timeInputWrapper {\n  display: inline-flex;\n  padding: 0 ' + theme.timeInputWrapperPadding + ';\n}\n\n.Timer__styles__timeInfo {\n  padding: ' + theme.timeInfoPadding + ' 0;\n}\n\n.Timer__styles__errors {\n  padding: ' + theme.errorPadding + ';\n}\n';
  },
  'wrapper': 'Timer__styles__wrapper',
  'inputsWrapper': 'Timer__styles__inputsWrapper',
  'timeInputWrapper': 'Timer__styles__timeInputWrapper',
  'timeInfo': 'Timer__styles__timeInfo',
  'errors': 'Timer__styles__errors'
};


var HOURS_LIMIT = 168;
var MINUTES_LIMIT = 90;
var LIMIT_IN_SECONDS = HOURS_LIMIT * _FormattedDuration.HOUR_IN_SECONDS;

function parseNumber(n) {
  return parseInt(n, 10) || 0;
}

var BuildingTimer = (_dec = (0, _lib2.default)(_theme2.default, styles), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(BuildingTimer, _Component);

  function BuildingTimer(props) {
    (0, _classCallCheck3.default)(this, BuildingTimer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (BuildingTimer.__proto__ || Object.getPrototypeOf(BuildingTimer)).call(this, props));

    _initialiseProps.call(_this);

    var _getHoursMinutesSecon = (0, _FormattedDuration.getHoursMinutesSeconds)(props.sessionTimeLimitInSeconds),
        hours = _getHoursMinutesSecon.hours,
        minutes = _getHoursMinutesSecon.minutes;

    _this.state = {
      hours: hours,
      minutes: minutes,
      errors: {
        hours: null,
        minutes: null
      }
    };
    return _this;
  }

  (0, _createClass3.default)(BuildingTimer, [{
    key: 'convertToSeconds',
    value: function convertToSeconds(hours, minutes) {
      return hours * _FormattedDuration.HOUR_IN_SECONDS + minutes * _FormattedDuration.MINUTE_IN_SECONDS;
    }
  }, {
    key: 'render',
    value: function render() {
      var hasTimeLimit = this.props.hasTimeLimit;

      return _react2.default.createElement(
        _Setting2.default,
        {
          automationData: 'sdk-timeLimit-toggle',
          isChecked: hasTimeLimit,
          label: '\u65F6\u95F4\u9650\u5236',
          onChange: this.toggleHasTimeLimit,
          showMore: hasTimeLimit
        },
        _react2.default.createElement(
          'div',
          { className: styles.wrapper },
          _react2.default.createElement(
            'div',
            { className: styles.inputsWrapper },
            _react2.default.createElement(
              'span',
              { className: styles.timeInputWrapper },
              _react2.default.createElement(_quizNumberInput2.default, {
                label: _react2.default.createElement(
                  _Text2.default,
                  { weight: 'light', color: 'secondary', size: 'small' },
                  '\u5C0F\u65F6\u6570'
                ),
                inline: true,
                width: '5.5rem',
                value: this.state.hours,
                min: '0',
                onChange: this.handleHoursChange,
                'data-automation': 'sdk-timeLimit-hours'
              })
            ),
            _react2.default.createElement(
              'span',
              { className: styles.timeInputWrapper },
              _react2.default.createElement(_quizNumberInput2.default, {
                label: _react2.default.createElement(
                  _Text2.default,
                  { weight: 'light', color: 'secondary', size: 'small' },
                  '\u5206\u949F'
                ),
                inline: true,
                width: '5.5rem',
                value: this.state.minutes,
                min: '0',
                onChange: this.handleMinutesChange,
                'data-automation': 'sdk-timeLimit-minutes'
              })
            )
          ),
          _react2.default.createElement(
            'div',
            { className: styles.errors },
            _react2.default.createElement(_Errors2.default, { errorList: this.state.errors.hours || (0, _immutable.List)() }),
            _react2.default.createElement(_Errors2.default, { errorList: this.state.errors.minutes || (0, _immutable.List)() })
          ),
          _react2.default.createElement(
            'div',
            { className: styles.timeInfo },
            _react2.default.createElement(
              _Text2.default,
              { weight: 'light', color: 'secondary', size: 'small' },
              '\u8BBE\u7F6E 0 \u4E3A\u65E0\u65F6\u95F4\u9650\u5236'
            )
          )
        )
      );
    }
  }]);
  BuildingTimer.displayName = 'BuildingTimer'
  ;
  return BuildingTimer;
}(_react.Component), _class2.propTypes = {
  setQuizHasTimeLimit: _propTypes2.default.func.isRequired,
  setSessionTimeLimitInSecondsUi: _propTypes2.default.func.isRequired,
  setSessionTimeLimitInSecondsApi: _propTypes2.default.func.isRequired,
  sessionTimeLimitInSeconds: _propTypes2.default.number,
  hasTimeLimit: _propTypes2.default.bool.isRequired,
  activeQuizId: _propTypes2.default.string.isRequired
}, _class2.defaultProps = {
  sessionTimeLimitInSeconds: 0
}, _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.toggleHasTimeLimit = function (event) {
    var _props = _this2.props,
        setQuizHasTimeLimit = _props.setQuizHasTimeLimit,
        activeQuizId = _props.activeQuizId;

    var value = event.target.checked;
    setQuizHasTimeLimit(activeQuizId, value);
    _this2.setState({ errors: { minutes: null, hours: null } });
  };

  this.setNewLimit = function (hours, minutes) {
    var _props2 = _this2.props,
        setSessionTimeLimitInSecondsApi = _props2.setSessionTimeLimitInSecondsApi,
        setSessionTimeLimitInSecondsUi = _props2.setSessionTimeLimitInSecondsUi,
        activeQuizId = _props2.activeQuizId;

    var limitInSeconds = _this2.convertToSeconds(hours, minutes);
    setSessionTimeLimitInSecondsUi(activeQuizId, limitInSeconds);
    // make sure we have a valid limit before calling the api
    if (limitInSeconds <= LIMIT_IN_SECONDS && minutes <= MINUTES_LIMIT) {
      // TODO: debounce these updates
      setSessionTimeLimitInSecondsApi(activeQuizId, limitInSeconds);
    }
  };

  this.handleTimeChange = function (hours, minutes) {
    var hoursMsg = void 0,
        minutesMsg = void 0;
    if (hours > HOURS_LIMIT) {
      hoursMsg = _default_zhHans_number(hours) + ' \u5C0F\u65F6\u6570\u8D85\u51FA\u6700\u5927\u9650\u5236 ' + _default_zhHans_number(HOURS_LIMIT) + '\u3002';
    } else if (_this2.convertToSeconds(hours, minutes) > LIMIT_IN_SECONDS) {
      var _s, _n, _i, _v;

      minutesMsg = (_s = minutes, _n = +_s, (_i = Math.floor(Math.abs(+_s)), _v = (_s + '.').split('.')[1].length, _i === 1 && _v === 0 ? _default_zhHans_number(minutes) + ' \u5206\u949F' : _default_zhHans_number(minutes) + ' \u5206\u949F')) + ' \u5C06\u5BFC\u81F4\u5C0F\u65F6\u6570\u8D85\u8FC7\u6700\u5927\u5C0F\u65F6\u6570\u9650\u5236 ' + _default_zhHans_number(HOURS_LIMIT) + '\u3002';
    }
    if (minutes > MINUTES_LIMIT) {
      minutesMsg = _default_zhHans_number(minutes) + ' \u5206\u949F\u6570\u8D85\u51FA\u6700\u5927\u9650\u5236 ' + _default_zhHans_number(MINUTES_LIMIT) + '\u3002';
    }
    _this2.setState({
      hours: hours,
      minutes: minutes,
      errors: { minutes: (0, _immutable.List)([minutesMsg]), hours: (0, _immutable.List)([hoursMsg]) }
    });
    _this2.setNewLimit(hours, minutes);
  };

  this.handleHoursChange = function (event, value, normalizedValue) {
    var hours = parseNumber(normalizedValue);
    var minutes = _this2.state.minutes;
    _this2.handleTimeChange(hours, minutes);
  };

  this.handleMinutesChange = function (event, value, normalizedValue) {
    var minutes = parseNumber(normalizedValue);
    var hours = _this2.state.hours;
    _this2.handleTimeChange(hours, minutes);
  };
}, _temp)) || _class);
exports.default = BuildingTimer;