'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _constants = require('quiz-common/lib/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addQuizSessionResults = function addQuizSessionResults(state, action) {
  var quizSessionResultsHash = (0, _keyBy2.default)(action.payload, 'id');
  return state.mergeDeep(quizSessionResultsHash);
};

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.fromJS)({});
  var action = arguments[1];

  switch (action.type) {
    case _constants.ADD_QUIZ_SESSION_RESULTS:
      return addQuizSessionResults(state, action);
    default:
      return state;
  }
};